function setupEventProcessing(user) 
{
	serverEventListeners = [];
	// Subscribe to server events
	if (typeof (EventSource) !== "undefined") {
		var source = new EventSource('/UserHandlers/EventProcessor.ashx?id='+user);
		source.addEventListener("open", function (event) {
		}, false);
		source.addEventListener("error", function (event) {
			if (event.eventPhase == EventSource.CLOSED) {
			}
		}, false);
		source.addEventListener("message", function (event) {
			var object = JSON.parse(event.data);
			serverEventListeners.forEach(function (listener) {
				if (listener.id == undefined || listener.id == object.id)
					listener.onEvent(object);
			});
		}, false);
	}
}
