var lookup = function (element, text)
{
	//DFS Recursive way of finding text on each level
	//Visible only works on elements that take up space(i.e. not fixed position elements)
	var results = element.children('*');

	//Look at the text at each level with the children removed
	var newText = '';
	results.each(function (index, value)
	{
		if ($(value)[0].nodeName != "SCRIPT" &&
			$(value)[0].nodeName != "META" &&
			$(value)[0].nodeName != "IMG" &&
			$(value)[0].nodeName != "LINK" &&
			$(value)[0].nodeName != "NOSCRIPT" &&
			$(value)[0].nodeName != "STYLE")
		{
			//alert($(value)[0].nodeName);
			newText += $(value).clone()
				.children()
				.remove()
				.end()
				.text() + " ";
		}
	});

	var moreResultText = '';
	results.each(function (index, value)
	{
		moreResultText += lookup($(value), ' ');
	})

	if (results.length > 0)
	{
		return text + newText + moreResultText;
	} else
	{
		return text;
	}
};

function httpGet(theUrl, func)
{
	if (window.XMLHttpRequest)
	{// code for IE7+, Firefox, Chrome, Opera, Safari
		xmlhttp = new XMLHttpRequest();
	}
	else
	{// code for IE6, IE5
		xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	}
	xmlhttp.onreadystatechange = function ()
	{
		if (xmlhttp.readyState == 4 && xmlhttp.status == 200)
		{
			func(xmlhttp.responseText);
		}
	}
	xmlhttp.open("GET", theUrl, true);
	xmlhttp.send();
}

extractTextFromHTML = function(text)
{
	function extractContent(s)
	{
		var span = document.createElement('div');
		span.id = "TEMP";
		span.innerHTML = s;
		$("body")[0].appendChild(span);
	};

	extractContent(text);
	var output = lookup($("#TEMP"), '');
	$("#TEMP").remove();
	return output;
}

confirmDialog=function(title, msg, funcOk, funcCancel)
{
	$("#ConfirmDialog").attr("title", title);
	$("#ConfirmText").text(msg);
	$("#ConfirmDialog").dialog({
		resizable: false,
		height: "auto",
		width: "auto",
		position: { my: "center", at: "center" },
		modal: true,
		buttons: {
			Ok: function ()
			{
				funcOk();
				$(this).dialog("close");
			},
			Cancel: function ()
			{
				funcCancel();
				$(this).dialog("close");
			}
		}
	});
}
